#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_StarLotteryVIPChipEachDayLimitCFG.h"
std::auto_ptr<M_StarLotteryVIPChipEachDayLimitCFG> M_StarLotteryVIPChipEachDayLimitCFG::msSingleton(nullptr);

int M_StarLotteryVIPChipEachDayLimitCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_StarLotteryVIPChipEachDayLimitCFGData* M_StarLotteryVIPChipEachDayLimitCFG::GetData(int CreateDays)
{
	auto it = mMapData.find(CreateDays);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_StarLotteryVIPChipEachDayLimitCFGData>& M_StarLotteryVIPChipEachDayLimitCFG::GetMapData()
{
	return mMapData;
}

void M_StarLotteryVIPChipEachDayLimitCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_StarLotteryVIPChipEachDayLimitCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_StarLotteryVIPChipEachDayLimitCFGData data;
		data.mCreateDays = element->IntAttribute("CreateDays");
		data.mGetMaxChip = element->IntAttribute("GetMaxChip");
		if (mMapData.find(data.mCreateDays) != mMapData.end())std::cout <<"data refind:" << data.mCreateDays << std::endl;
		CCASSERT(mMapData.find(data.mCreateDays) == mMapData.end(), "data.mCreateDays is exists");
		mMapData.insert(std::make_pair(data.mCreateDays, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_StarLotteryVIPChipEachDayLimitCFG Loaded. Load Data:%u", mMapData.size());
}

void M_StarLotteryVIPChipEachDayLimitCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_StarLotteryVIPChipEachDayLimitCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_StarLotteryVIPChipEachDayLimitCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_StarLotteryVIPChipEachDayLimitCFGData data;
		LuaCfgHelper::readInt(L, "CreateDays", data.mCreateDays);
		LuaCfgHelper::readInt(L, "GetMaxChip", data.mGetMaxChip);
		if (mMapData.find(data.mCreateDays) != mMapData.end())std::cout <<"data refind:" << data.mCreateDays << std::endl;
		CCASSERT(mMapData.find(data.mCreateDays) == mMapData.end(), "data.mCreateDays is exists");
		mMapData.insert(std::make_pair(data.mCreateDays, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_StarLotteryVIPChipEachDayLimitCFG Loaded. Load Data:%u", mMapData.size());
}

void M_StarLotteryVIPChipEachDayLimitCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_StarLotteryVIPChipEachDayLimitCFG* M_StarLotteryVIPChipEachDayLimitCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_StarLotteryVIPChipEachDayLimitCFG());
	}
	return msSingleton.get();
}

void M_StarLotteryVIPChipEachDayLimitCFG::Release()
{
	msSingleton.reset(nullptr);
}
